<template>
  <ob-form
    :form-data="formData"
    :form-model="formModel"
    :is-read-only="!isNew"
    @submit="onSubmitHandler"
    :dropdown-menu="dropdownMenu"
  >
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          :label="dictionaryRu.modal.denomination"
          :placeholder="dictionaryRu.modal.denomination_placeholder"
          v-model="formData.denomination"
          :disabled="!isNew"
          property="denomination"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-6">
        <ob-input
          :label="dictionaryRu.modal.shorthand"
          :placeholder="dictionaryRu.modal.shorthand_placeholder"
          v-model="formData.shorthand"
          :disabled="!isNew"
          property="shorthand"
        />
      </div>
      <div class="col-xs-6">
        <ob-input
          :label="dictionaryRu.modal.international_shorthand"
          :placeholder="dictionaryRu.modal.international_shorthand_placeholder"
          v-model="formData.international_shorthand"
          :disabled="!isNew"
          property="international_shorthand"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-textarea
          :label="dictionaryRu.modal.description"
          v-model="formData.description"
          :disabled="!isNew"
          property="description"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin';
import models              from '@/models';
import cloneDeep           from 'clone-deep';
import ObForm              from 'common-components/src/obComponents/obForm';
import ObInput             from 'common-components/src/obComponents/obInput';
import ObTextarea          from 'common-components/src/obComponents/obTextarea';
import dropdownEvents      from '@/mixins/dictionaries/dropdown-events';
import { dictionary } from '@/translations/ru/dictionaries__resources__forwarding_unit';

export default {
  name: 'ForwardingUnit',
  data() {
    return {
      dictionaryRu: dictionary
    }
  },
  components: {
    ObTextarea,
    ObInput,
    ObForm
  },
  mixins: [
    FormValidationMixin,
    dropdownEvents
  ],
  props: {
    dataSource: {
      type: Object,
      default: () => {}
    }
  },
  computed: {
    formModel() {
      return models.forwardUnit.add;
    },
    isNew() {
      return !this.formData.uuid;
    }
  },
  methods: {
    onSubmitHandler() {
      const data = cloneDeep(this.formData);

      this.$emit('submit', { formData: data, model: this.formModel });
    }
  }
};
</script>
